exports.version = "0.5.0";

// push numbers on to a stock, pop when we see an operator.
exports.compute = function (parts) {
	var stack = [];
	for (var i = 0; i < parts.length; i++) {
		switch (parts[i]) {
			case '+': case '-': case '*': case '/':
				if (stack.length < 2) return false;
				do_op(stack, parts[i]);
				break;
			  default:
			  	var num = parseFloat(parts[i]);
			  	if (isNaN(num)) return false;
			  	stack.push(num);
			  	break;
		}
	}
	if (stack.length != 1) return false;
	return stack.pop();
}

function do_op(stack, operator) {
	var b = stack.pop();
	var a = stack.pop();
	switch (operator) {
		case '+': stack.push(a + b); break;
		case '-': stack.push(a - b); break;
		case '*': stack.push(a * b); break;
		case '/': stack.push(a / b); break;
		default: throw new Error('Unexpected operator');
	}
}